
#include "stm32f10x.h"
#include "usart.h"

/* USART Control Functions *****************************************/

#define CHAR_NULL 0x00
#define CHAR_CR   0x0d
#define CHAR_LF   0x0a

/* return code is windows type */
#define PUT_NEWLINE  usart_putc(CHAR_CR); usart_putc(CHAR_LF)

void usart_init(){
    
    USART_InitTypeDef USART_InitStructure;
    
    USART_InitStructure.USART_BaudRate = 9600;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No ;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
    
    USART_Init(USART1, &USART_InitStructure);
    /* Enable the USART1 */
    USART_Cmd(USART1, ENABLE);
    
}

void usart_putc(const char c){
    while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);
    USART_SendData(USART1, c);
    while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);
}

void usart_putc_nowait(const char c){
    while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);
    USART_SendData(USART1, c);
}

char usart_getc(){
    while(USART_GetFlagStatus(USART1, USART_FLAG_RXNE) == RESET);
    return USART_ReceiveData(USART1);USART_ReceiveData(USART1);
}


int usart_received(){
    if(USART_GetFlagStatus(USART1, USART_FLAG_RXNE) == RESET){
        return 0;
    }
    
    return 1;
}


/* send string to PC */
void usart_printstr(const char* str){

    while(*str != CHAR_NULL) {

        
        if(*str == '\n'){
            PUT_NEWLINE;
        }else{
            usart_putc(*str);
        }
        
        str++;
    }
}

/* recive string from PC */
void usart_inputstr(char* str){
    char c;

    while(1){
        c = usart_getc();
        
        if(c == CHAR_CR){
            *str = CHAR_NULL;
            break;
        }
        
        *str = c;
        str++;
        
    }

}

/* recive string from PC with redirect */
void usart_scanstr(char* str){
    char c;

    while(1){
        c = usart_getc();
        
        if(c == CHAR_CR){
            usart_putc(CHAR_CR);
            usart_putc(CHAR_LF);
            *str = CHAR_NULL;
            break;
        }
        
        usart_putc(c);
        *str = c;
        str++;
        
    }
}


